#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include "esftypes.h"

/* ----------------------------------------------------------------------
Summary of the most important user-level functions

ESF_EMPTY
  The constant empty array with no elements.  It always exists,
  and isn't created by the user program.

int esfc_update (int a, int i, int v)
  a2 = esfc_update (a1,i,v)
  a2 is a new array with the same contents as a1, except that a2[i] = v
     (it doesn't matter whether a1[i] was defined)
  The old array a1 is not changed by the update.

int esfc_lookup (int a, int i)
  returns a[i]

int esfc_maxindex (int a)
  returns the maximum index where a has a defined value

int esfc_minindex (int a)
  returns the minimum index where a has a defined value

int esfc_nextindex (int a, int Index)
  returns the next index > ind where a is defined
  If no such index exists, returns INT_MAX

int esfc_previndex (int a, int ind)
  returns the next index < ind where a is defined
  If no such index exists, returns INT_MIN

---------------------------------------------------------------------- */



int esfaUpdate (int a, int i, int v)
{ int r;
  r = esfc_update (a,i,v);
  return r;
}

int esfaLookup (int a, int i)
{ int r;
  r = esfc_lookup (a,i);
  return r;
}

void esfaInit ()
{ esfc_init ();
}

int esfaMaxIndex (int a)
{ int r;
  r = esfc_maxindex (a);
  return r;
}

int esfaMinIndex (int a)
{ int r;
  r = esfc_minindex (a);
  return r;
}

int esfaNextIndex (int a, int i)
{ int r;
  r = esfc_nextindex (a,i);
  return r;
}

int esfaPrevIndex (int a, int i)
{ int r;
  r = esfc_previndex (a,i);
  return r;
}

void esfaDump ()
{ esfp_dump (0);
}

